import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import javax.imageio.ImageIO;
import java.awt.image.BufferedImage;
import java.io.*;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
class ImgEdit extends Frame{
	Image rawImg;	//Reference to original image
  	int imgCols;	//Number of horizontal pixels
  	int imgRows;	//Number of rows of pixels
  	Image modImg;	//Reference to modified image
	Frame modimg;	//Frame to display the modified Image
	Frame opFrm;	//Frame for dispalying options
//	Frame sf=new Frame("Save Image");
	BufferedImage bi;
	TextField input;
 	int inTop;
 	int inLeft;

 	
  	static String theProcessingClass="blur";
		  
  	static String theImgFile = "pic.jpg";

  	MediaTracker tracker;
 	Display display = new Display();
	Display moddisp=new Display();  
	Button blurButton = new Button("Blur");
	Button edgeButton = new Button("Edge");
	Button shrpButton = new Button("Sharpen");
	Button invrtButton = new Button("Invert");
	Button postButton = new Button("Posterize");
	
	Button saveButton = new Button("Save");
	Button openButton = new Button("Open");
  		
  	byte[][][] threeDPix;
  	byte[][][] threeDPixMod;
  	int[] oneDPix;

 		
  	ImgInterface imageProcessingObject;
  	

 	 public static void main(String[] args){

   		 //Get names for the image-processing program and the image file to be processed.
    		// Program supports gif files and jpg files and possibly some other file types as well.
    	if(args.length == 0){
      		
    	}else if(args.length == 1){
      		theImgFile = args[0];
		int i=0;
		for(i=0;i<theImgFile.length();i++)
			if(theImgFile.charAt(i)=='.')break;
		if(i==theImgFile.length())theImgFile+=".jpg";
      
    		}
	else{
     	 System.out.println("Invalid args");
     	 System.exit(1);
   	 }

   

    //Instantiate an object of this class
    	ImgEdit obj = new ImgEdit(theImgFile);
  	}//end main
 

  	public ImgEdit(String theImgFile){	//constructor
    		//Get an image from the specified file.  Can be in a different directory 
		//if the path was entered with the file name on the command line.
    	rawImg = Toolkit.getDefaultToolkit().
                            getImage(theImgFile);

    		//Use a MediaTracker object to block until the image is loaded or ten seconds has elapsed.
   	 tracker = new MediaTracker(this);
   	 tracker.addImage(rawImg,1);

    	try{
     		 if(!tracker.waitForID(1,10000)){
        		System.out.println("Load error.");
      		}
    	}catch(InterruptedException e){
      	e.printStackTrace();
     	 System.exit(1);
   	 }

    		//Make certain that the file was successfully loaded.
    	if((tracker.statusAll(false)& MediaTracker.ERRORED & MediaTracker.ABORTED) != 0){
     	 System.out.println("Load errored or aborted");
      	System.exit(1);
    	}

   		 
    	imgCols = rawImg.getWidth(this);
//	if(imgCols>500)imgCols=500;
    	imgRows = rawImg.getHeight(this);
//	if(imgRows>500)imgRows=500;
	display.setImg(rawImg);
    	this.setTitle("Original Image");
    	this.setBackground(Color.YELLOW);
    	this.add(display);
	opFrm=new Frame("Option Panel");
	opFrm.setBackground(Color.WHITE);
	opFrm.setLayout(new FlowLayout());
	modimg=new Frame();
	modimg.setTitle("Modified Image");
	modimg.setBackground(Color.WHITE);
	
	modimg.add(moddisp);
    	opFrm.add(openButton,BorderLayout.SOUTH);
    	opFrm.add(blurButton,BorderLayout.SOUTH);
	opFrm.add(shrpButton,BorderLayout.SOUTH);
	opFrm.add(edgeButton,BorderLayout.SOUTH);
	opFrm.add(invrtButton,BorderLayout.SOUTH);
	opFrm.add(postButton,BorderLayout.SOUTH);

	opFrm.add(saveButton,BorderLayout.SOUTH);
    			
    	setVisible(true);
	
	opFrm.setVisible(true);
    			
//	sf.setLayout(new FlowLayout());
//	sf.setSize(300,100);
//	Label text=new Label("Enter the file name:");
//	input=new TextField(theImgFile+"_edited.jpg",20);
//	Button sa=new Button("Save");
//	sf.add(text);
//	sf.add(input);
	
/*	
	sa.addActionListener(
		new ActionListener(){
			public void actionPerformed(ActionEvent e){
				try
        			{
            				ImageIO.write(bi, "jpg", new File(input.getText()));
        			}
        			catch(IOException ioe)
        			{
           				 System.out.println("write: " + ioe.getMessage());
        			}
				sf.setVisible(false);
				
			}
		}
	);
	sf.add(sa);
	sf.addWindowListener(
		new WindowAdapter(){
			public void windowClosing(WindowEvent e){
				
				sf.setVisible(false);
				
			}
		}
	);
 */
   	inTop = this.getInsets().top;
   	 inLeft = this.getInsets().left;
  	
    			
	opFrm.setSize(imgCols,100);
	this.setSize(inLeft+imgCols,inTop+imgRows);
	modimg.setSize(inLeft+imgCols,inTop+imgRows);
    			
    	openButton.addActionListener(
	new ActionListener(){
		public void actionPerformed(ActionEvent e){
		
			String filename = "";
			JFileChooser fc = new JFileChooser(new File(filename));
	
			// Show open dialog; this method does not return until the dialog is closed
			fc.showOpenDialog(null);
			File selFile = fc.getSelectedFile();
			System.out.println("New file opened:"+selFile.getPath());
		    	ImgEdit obj = new ImgEdit(selFile.getPath());
			
		}
	}
	);

	blurButton.addActionListener(
      	new ActionListener(){
        	public void actionPerformed(ActionEvent e){
          		
        		imageProcessingObject = new blur();  
			
			threeDPixMod = imageProcessingObject.processImg(threeDPix,imgRows,imgCols);
          		
          		oneDPix = convertToOneDim(
                   	threeDPixMod,imgCols,imgRows);

          		modImg = createImage(new MemoryImageSource(imgCols,imgRows,oneDPix,0,imgCols));
          		
       			moddisp.setImg(modImg);  
			modimg.setVisible(true);
			display.repaint();
			moddisp.repaint();
        	}//end actionPerformed
     	 }//end ActionListener
    	);//end addActionListener
    
	saveButton.addActionListener(
      	new ActionListener(){
 		public void actionPerformed(ActionEvent e){
			String filename = "";
			JFileChooser fc = new JFileChooser(new File(filename));
			fc.showSaveDialog(null);
			File selFile = fc.getSelectedFile();
			int w = modImg.getWidth(null);
			int h = modImg.getHeight(null);
			bi = new BufferedImage(w, h, BufferedImage.TYPE_INT_RGB);
			Graphics2D g2 = bi.createGraphics();
			g2.drawImage(modImg, 0, 0, null);
			g2.dispose();
			try{
            			ImageIO.write(bi, "jpg", selFile);
        		}
        		catch(IOException ioe){
       				 System.out.println("write: " + ioe.getMessage());
       			}
        	}//end actionPerformed
      	}//end ActionListener
    	);//end addActionListener
    
	
	postButton.addActionListener(
      	new ActionListener(){
        	public void actionPerformed(ActionEvent e){
          		
        		imageProcessingObject = new posterize();  
			threeDPixMod = imageProcessingObject.processImg(threeDPix,imgRows,imgCols);
          		oneDPix = convertToOneDim( threeDPixMod,imgCols,imgRows);
          		modImg = createImage(new MemoryImageSource(imgCols,imgRows,oneDPix,0,imgCols));
          		moddisp.setImg(modImg);  
			modimg.setVisible(true);
			display.repaint();
			moddisp.repaint();
        	}//end actionPerformed
      	}//end ActionListener
    	);//end addActionListener
    
	edgeButton.addActionListener(
      	new ActionListener(){
        	public void actionPerformed(ActionEvent e){
          		
        		imageProcessingObject = new edge();  
			threeDPixMod = imageProcessingObject.processImg(threeDPix,imgRows,imgCols);
          		
          		oneDPix = convertToOneDim(threeDPixMod,imgCols,imgRows);
          		
          		modImg = createImage(new MemoryImageSource(imgCols,imgRows,oneDPix,0,imgCols));
          		
			moddisp.setImg(modImg);
			modimg.setVisible(true);  
			display.repaint();
			moddisp.repaint();
        	}//end actionPerformed
      	}//end ActionListener
    	);//end addActionListener
    
	shrpButton.addActionListener(
      	new ActionListener(){
        	public void actionPerformed(ActionEvent e){
          		
        		imageProcessingObject = new sharpen();  
			threeDPixMod = imageProcessingObject.processImg(threeDPix,imgRows,imgCols);
          		
          		oneDPix = convertToOneDim(threeDPixMod,imgCols,imgRows);
          		
          		modImg = createImage(new MemoryImageSource(imgCols,imgRows,oneDPix,0,imgCols));
          		
			moddisp.setImg(modImg);
			modimg.setVisible(true);  
			display.repaint();
			moddisp.repaint();
        	}//end actionPerformed
      	}//end ActionListener
    	);//end addActionListener
    
	invrtButton.addActionListener(
      	new ActionListener(){
        	public void actionPerformed(ActionEvent e){
          		
			imageProcessingObject = new invert();  
			threeDPixMod = imageProcessingObject.processImg(threeDPix,imgRows,imgCols);
			oneDPix = convertToOneDim(threeDPixMod,imgCols,imgRows);
			modImg = createImage(new MemoryImageSource(imgCols,imgRows,oneDPix,0,imgCols));
			moddisp.setImg(modImg);
			modimg.setVisible(true);  
			display.repaint();
			moddisp.repaint();
		}//end actionPerformed
      	}//end ActionListener
    	);//end addActionListener
    
    oneDPix = new int[imgCols * imgRows];

    
    try{
      
      PixelGrabber pgObj = new PixelGrabber(
                      rawImg,0,0,imgCols,imgRows,
                              oneDPix,0,imgCols);
     
      if(pgObj.grabPixels() &&
                           ((pgObj.getStatus() &
                           ImageObserver.ALLBITS)
                                          != 0)){

       
        threeDPix = convertToThreeDim(
                        oneDPix,imgCols,imgRows);

        
        try{
          imageProcessingObject = (
               ImgInterface)Class.forName(
               theProcessingClass).newInstance();

           
        }catch(Exception e){
          System.out.println("after toolkit thing"+e);
        }

      }
      else System.out.println(
                    "Pixel grab not successful");
    }catch(InterruptedException e){
      System.out.println("above printstacktrace");
	e.printStackTrace();
    }

    
    this.setVisible(true);
	
	modimg.addWindowListener(
		new WindowAdapter(){
			public void windowClosing(WindowEvent e){
				
				modimg.setVisible(false);
				modImg=null;
			}
		}
	);
	
    this.addWindowListener(
      new WindowAdapter(){
        public void windowClosing(WindowEvent e){
          System.exit(0);//terminate the program
        }
      }
    );
    

  }//end constructor
 

 
  class Display extends Canvas{
    
    	Image img;
	Display(){
	img=null;
	}
	void setImg(Image img){
		this.img=img;
	}
	public void paint(Graphics g){
     
      if (tracker.statusID(1, false) ==
                          MediaTracker.COMPLETE){
        if((img != null) ){
          g.drawImage(img,0,0,this);
        
        }//end if
      }//end if
    }//end paint()
  }

  
  byte[][][] convertToThreeDim(
          int[] oneDPix,int imgCols,int imgRows){
  
    byte[][][] data =new byte[imgRows][imgCols][4];

    for(int row = 0;row < imgRows;row++){
      
      int[] aRow = new int[imgCols];
      for(int col = 0; col < imgCols;col++){
        int element = row * imgCols + col;
        aRow[col] = oneDPix[element];
      }

      
      for(int col = 0;col < imgCols;col++){
       
        data[row][col][0] = (byte)((aRow[col] >> 24)& 0xFF);
       
        data[row][col][1] = (byte)((aRow[col] >> 16)& 0xFF);
      
        data[row][col][2] = (byte)((aRow[col] >> 8) & 0xFF);
      
        data[row][col][3] =(byte)((aRow[col]) & 0xFF);
      }
    }
    return data;
  }
  
  int[] convertToOneDim(
         byte[][][] data,int imgCols,int imgRows){
   
    int[] oneDPix = new int[imgCols * imgRows * 4];

    
    for(int row = 0,cnt = 0;row < imgRows;row++){
      for(int col = 0;col < imgCols;col++){
        oneDPix[cnt] = (((int)(data[row][col][0]) << 24)
                                   & 0xFF000000)
                     | (((int)(data[row][col][1])<< 16)
                                   & 0x00FF0000)
                      | (((int)(data[row][col][2]) << 8)
                                   & 0x0000FF00)
                           | (((int)(data[row][col][3]))
                                   & 0x000000FF);
        cnt++;
      }

    }

    return oneDPix;
  }
}




class blur implements ImgInterface{

  

  public byte[][][] processImg(byte[][][] threeDPix,int imgRows,int imgCols){
    	byte[][][] temp3D =new byte[imgRows][imgCols][4];
   	try{ 	for(int row = 0;row < imgRows;row++){
      			for(int col = 0;col < imgCols;col++){
        			temp3D[row][col][0] =threeDPix[row][col][0];
        			temp3D[row][col][1] =threeDPix[row][col][1];
        			temp3D[row][col][2] =threeDPix[row][col][2];
        			temp3D[row][col][3] =threeDPix[row][col][3];
      			}
    		}
	}
	catch (Exception e){System.out.println("while assigning:"+e);}
	
	for(int row=1;row<imgRows-1;row++){	
	 for(int col = 1;col < imgCols-1;col++){
		
      		temp3D[row][col][1] = modify(threeDPix[row-1][col-1][1],threeDPix[row-1][col+1][1],threeDPix[row+1][col-1][1],threeDPix[row+1][col+1][1],threeDPix[row][col][1]);
      		temp3D[row][col][2] = modify(threeDPix[row-1][col-1][2],threeDPix[row-1][col+1][2],threeDPix[row+1][col-1][2],threeDPix[row+1][col+1][2],threeDPix[row][col][2]);
     		temp3D[row][col][3] = modify(threeDPix[row-1][col-1][3],threeDPix[row-1][col+1][3],threeDPix[row+1][col-1][3],threeDPix[row+1][col+1][3],threeDPix[row][col][3]);
 	}   }
	return temp3D;
	}
	byte modify(int a,int b,int c,int d,int e){
		a=(a>=0)?a:256+a;b=(b>=0)?b:256+b;c=(c>=0)?c:256+c;d=(d>=0)?d:256+d;e=(e>=0)?e:256+e;
		return (byte)((e+a+b+c+d)/5);
	}
}

class invert implements ImgInterface{

  
  public byte[][][] processImg( byte[][][] threeDPix,int imgRows,int imgCols){
	 byte[][][] temp3D =new byte[imgRows][imgCols][4];
    	try{ 	for(int row = 0;row < imgRows;row++){
      			for(int col = 0;col < imgCols;col++){
        			temp3D[row][col][0] =threeDPix[row][col][0];
        			temp3D[row][col][1] =threeDPix[row][col][1];
        			temp3D[row][col][2] =threeDPix[row][col][2];
        			temp3D[row][col][3] =threeDPix[row][col][3];
      			}
    		}
	}
	catch (Exception e){System.out.println("while assigning:"+e);}
	
	for(int row=1;row<imgRows-1;row++){	
	 for(int col = 1;col < imgCols-1;col++){
      		temp3D[row][col][0] = threeDPix[row][col][0];
		temp3D[row][col][1] = modify(threeDPix[row-1][col-1][1],threeDPix[row-1][col+1][1],threeDPix[row+1][col-1][1],threeDPix[row+1][col+1][1],threeDPix[row][col][1]);
      		temp3D[row][col][2] = modify(threeDPix[row-1][col-1][2],threeDPix[row-1][col+1][2],threeDPix[row+1][col-1][2],threeDPix[row+1][col+1][2],threeDPix[row][col][2]);
     		temp3D[row][col][3] = modify(threeDPix[row-1][col-1][3],threeDPix[row-1][col+1][3],threeDPix[row+1][col-1][3],threeDPix[row+1][col+1][3],threeDPix[row][col][3]);
 	 }   }
	return temp3D;
	}
	byte modify(int a,int b,int c,int d,int e){
		a=(a>=0)?a:256+a;b=(b>=0)?b:256+b;c=(c>=0)?c:256+c;d=(d>=0)?d:256+d;e=(e>=0)?e:256+e;
		return (byte)(255-e);
	}
}
class posterize implements ImgInterface{
	 public byte[][][] processImg(byte[][][] threeDPix,int imgRows,int imgCols){
    		byte[][][] temp3D =new byte[imgRows][imgCols][4];
		try{ 	for(int row = 0;row < imgRows;row++){
				for(int col = 0;col < imgCols;col++){
					temp3D[row][col][0] =threeDPix[row][col][0];
					temp3D[row][col][1] =threeDPix[row][col][1];
					temp3D[row][col][2] =threeDPix[row][col][2];
					temp3D[row][col][3] =threeDPix[row][col][3];
				}
			}
		}
		catch (Exception e){System.out.println("while assigning:"+e);}
	
	for(int row=1;row<imgRows-1;row++){	
	 for(int col = 1;col < imgCols-1;col++){
      		temp3D[row][col][0] = threeDPix[row][col][0];
		temp3D[row][col][1] = modify(threeDPix[row-1][col-1][1],threeDPix[row-1][col+1][1],threeDPix[row+1][col-1][1],threeDPix[row+1][col+1][1],threeDPix[row][col][1]);
      		temp3D[row][col][2] = modify(threeDPix[row-1][col-1][2],threeDPix[row-1][col+1][2],threeDPix[row+1][col-1][2],threeDPix[row+1][col+1][2],threeDPix[row][col][2]);
     		temp3D[row][col][3] = modify(threeDPix[row-1][col-1][3],threeDPix[row-1][col+1][3],threeDPix[row+1][col-1][3],threeDPix[row+1][col+1][3],threeDPix[row][col][3]);
 	 }   }
	return temp3D;
	}
	byte modify(int a,int b,int c,int d,int e){
		a=(a>=0)?a:256+a;b=(b>=0)?b:256+b;c=(c>=0)?c:256+c;d=(d>=0)?d:256+d;e=(e>=0)?e:256+e;
		return (byte)(e-e%32);
	}
}
class sharpen implements ImgInterface{

  

  public byte[][][] processImg(byte[][][] threeDPix,int imgRows,int imgCols){
    	byte[][][] temp3D =new byte[imgRows][imgCols][4];
    	try{ 	for(int row = 0;row < imgRows;row++){
      			for(int col = 0;col < imgCols;col++){
        			temp3D[row][col][0] =threeDPix[row][col][0];
        			temp3D[row][col][1] =threeDPix[row][col][1];
        			temp3D[row][col][2] =threeDPix[row][col][2];
        			temp3D[row][col][3] =threeDPix[row][col][3];
      			}
    		}
	}
	catch (Exception e){System.out.println("while assigning:"+e);}
	
	for(int row=1;row<imgRows-1;row++){	
	 for(int col = 1;col < imgCols-1;col++){
	temp3D[row][col][1] = modify(threeDPix[row-1][col-1][1],threeDPix[row-1][col+1][1],threeDPix[row+1][col-1][1],threeDPix[row+1][col+1][1],threeDPix[row][col][1]);
      	temp3D[row][col][2] = modify(threeDPix[row-1][col-1][2],threeDPix[row-1][col+1][2],threeDPix[row+1][col-1][2],threeDPix[row+1][col+1][2],threeDPix[row][col][2]);
     	temp3D[row][col][3] = modify(threeDPix[row-1][col-1][3],threeDPix[row-1][col+1][3],threeDPix[row+1][col-1][3],threeDPix[row+1][col+1][3],threeDPix[row][col][3]);
 	
      }   }
	return temp3D;
	}
	byte modify(int a,int b,int c,int d,int e){
		a=(a>=0)?a:256+a;b=(b>=0)?b:256+b;c=(c>=0)?c:256+c;d=(d>=0)?d:256+d;e=(e>=0)?e:256+e;
		int r=4*e-a-b-c-d;
		
		int g=e+r;
		if(g>255)g=255;
		if(g<0)g=0;
		
		return (byte)g;
	}
}
class edge implements ImgInterface{
	
  
  public byte[][][] processImg(byte[][][] threeDPix,int imgRows,int imgCols){
    	byte[][][] temp3D =new byte[imgRows][imgCols][4];
    	try{ 	for(int row = 0;row < imgRows;row++){
      			for(int col = 0;col < imgCols;col++){
        			temp3D[row][col][0] =threeDPix[row][col][0];
        			temp3D[row][col][1] =threeDPix[row][col][1];
        			temp3D[row][col][2] =threeDPix[row][col][2];
        			temp3D[row][col][3] =threeDPix[row][col][3];
      			}
    		}
	}
	catch (Exception e){System.out.println("while assigning:"+e);}

    
	for(int row=1;row<imgRows-1;row++){	
	 for(int col = 1;col < imgCols-1;col++){
		temp3D[row][col][0] = (byte)(threeDPix[row][col][0]);
	temp3D[row][col][1] = modify(threeDPix[row-1][col-1][1],threeDPix[row-1][col+1][1],threeDPix[row+1][col-1][1],threeDPix[row+1][col+1][1],threeDPix[row][col][1]);
      	temp3D[row][col][2] = modify(threeDPix[row-1][col-1][2],threeDPix[row-1][col+1][2],threeDPix[row+1][col-1][2],threeDPix[row+1][col+1][2],threeDPix[row][col][2]);
     	temp3D[row][col][3] = modify(threeDPix[row-1][col-1][3],threeDPix[row-1][col+1][3],threeDPix[row+1][col-1][3],threeDPix[row+1][col+1][3],threeDPix[row][col][3]);
 	}   }
	return temp3D;
	}
	byte modify(int a,int b,int c,int d,int e){
		a=(a>=0)?a:256+a;b=(b>=0)?b:256+b;c=(c>=0)?c:256+c;d=(d>=0)?d:256+d;e=(e>=0)?e:256+e;
		int r=(4*e-a-b-c-d);
		r=(r>0)?r:0;
		
		return (byte)(r);
	}
}


 

/*File ImgInterface.java

===============================================*/

interface ImgInterface{
  	byte[][][] processImg(byte[][][] threeDPix,
                       int imgRows,
                       int imgCols);
	
}//end ImgInterface


